#
# Conditional build:
%bcond_without	asm	# x86 assembler
%bcond_without	doc	# don't build doc
%bcond_with	tests	# build tests (not useful, creates libgtest.a)
%bcond_without	ssse3	# use SSSE3 instructions (Intel since Core2, Via Nano)
%bcond_without	vp9_encoder	# vp9 encoder

%ifnarch %{ix86} %{x8664}
%undefine	with_asm
%endif

%if "%{pld_release}" == "ac"
# not supported by compiler
%undefine	with_ssse3
%endif

# old gcc gets stuck on ac
%ifarch sparc
%undefine	with_vp9_encoder
%endif

Summary:	VP8, a high-quality video codec
Summary(pl.UTF-8):	VP8 - kodek obrazu wysokiej jakości
Name:		libvpx
Version:	1.3.0
Release:	1
License:	BSD
Group:		Libraries
#Source0Download: http://code.google.com/p/webm/downloads/list
#Source0:	https://webm.googlecode.com/files/%{name}-v%{version}.tar.bz2
# source, but regenerated on each fetch
#Source0:	https://chromium.googlesource.com/webm/libvpx/+archive/v%{version}.tar.gz?/%{name}-%{version}.tar.gz
Source0:	%{name}-%{version}.tar.gz
# Source0-md5:	dcf436a5dc8b56bdfb4aec63b2fe6729
URL:		http://www.webmproject.org/
BuildRequires:	doxygen
%{?with_tests:BuildRequires:	libstdc++-devel}
BuildRequires:	pkgconfig
BuildRequires:	rpmbuild(macros) >= 1.673
BuildRequires:	sed >= 4.0
%{?with_asm:BuildRequires:	yasm >= 0.8}
%if %{with doc}
BuildRequires:	%{php_name}-pcre
BuildRequires:	%{php_name}-program
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define	generic_target	generic-gnu
%define	vpxtarget	%{generic_target}
%ifarch %{x8664}
%define	vpxtarget	x86_64-linux-gcc
%endif
%ifarch %{ix86}
%define	vpxtarget	x86-linux-gcc
%endif
%ifarch ppc
%define	vpxtarget	ppc32-linux-gcc
%endif
%ifarch ppc64
%define	vpxtarget	ppc64-linux-gcc
%endif

%description
VP8, a high-quality video codec.

%description -l pl.UTF-8
VP8 - kodek obrazu wysokiej jakości.

%package devel
Summary:	Header files for libvpx
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki libvpx
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
Header files for libvpx library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki libvpx.

%package static
Summary:	Static libvpx library
Summary(pl.UTF-8):	Statyczna biblioteka libvpx
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static libvpx library.

%description static -l pl.UTF-8
Statyczna biblioteka libvpx.

%prep
#%setup -q -n %{name}-v%{version}
%setup -qc

%build
install -d obj
cd obj
# not autoconf configure
CFLAGS="%{rpmcflags} %{rpmcppflags}" \
../configure \
%if %{with asm}
	--as=yasm \
%endif
	--target=%{vpxtarget} \
	--enable-shared \
	%{!?with_ssse3:--disable-ssse3} \
	--disable-optimizations \
	--%{!?with_tests:dis}%{?with_tests:en}able-unit-tests \
	--%{!?with_doc:dis}%{?with_doc:en}able-docs \
	--%{!?with_doc:dis}%{?with_doc:en}able-install-docs \
	--enable-vp8 \
	%{!?with_vp9_encoder:--disable-vp9-encoder} \
	--enable-postproc \
	--enable-runtime-cpu-detect

%{__make} verbose=true target=libs \
	HAVE_GNU_STRIP=no \
	CC="%{__cc}" \
	LD="%{__cc}" \
	LDFLAGS="%{rpmldflags}"

%{__make} verbose=true target=examples \
	CC="%{__cc}" \
	LD="%{__cc}" \
	LDFLAGS="%{rpmldflags} -L."

%if %{with doc}
%{__make} verbose=true target=docs
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_bindir},%{_includedir}/vpx,%{_libdir}}

%{__make} -C obj verbose=true install \
	LIBSUBDIR=%{_lib} \
	DIST_DIR=$RPM_BUILD_ROOT%{_prefix}

%{__rm} $RPM_BUILD_ROOT%{_libdir}/libvpx.so.1.3

# adjust prefix and libdir
%{__sed} -i -e 's,^prefix=.*,prefix=%{_prefix},;s,^libdir=.*,libdir=%{_libdir},' $RPM_BUILD_ROOT%{_pkgconfigdir}/vpx.pc

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc AUTHORS CHANGELOG LICENSE PATENTS README
%attr(755,root,root) %{_bindir}/vp8_scalable_patterns
%{?with_vp9_encoder:%attr(755,root,root) %{_bindir}/vp9_spatial_scalable_encoder}
%attr(755,root,root) %{_bindir}/vpxdec
%attr(755,root,root) %{_bindir}/vpxenc
%attr(755,root,root) %{_libdir}/libvpx.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libvpx.so.1

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libvpx.so
%{_includedir}/vpx
%{_pkgconfigdir}/vpx.pc

%files static
%defattr(644,root,root,755)
%{_libdir}/libvpx.a
%changelog
* Fri Dec 12 2014 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/libvpx.git;a=log;h=AC-branch

* Fri Dec 12 2014 Elan Ruusamäe <glen@delfi.ee> 44b3757
- disable vp9 encoder on ac-sparc

* Fri Nov 21 2014 Elan Ruusamäe <glen@delfi.ee> efdc9f5
- BR pkgconfig (bundled nestegg uses it)

* Fri Nov 21 2014 Elan Ruusamäe <glen@delfi.ee> ecadc52
- tests are not useful

* Fri Nov 21 2014 Elan Ruusamäe <glen@delfi.ee> 71ced3d
- compiling tests require g++

* Fri Nov 21 2014 Elan Ruusamäe <glen@delfi.ee> 06829e5
- enable shared now works for generic target as well

* Fri Nov 21 2014 Elan Ruusamäe <glen@delfi.ee> f0a288d
- configure enable/disable docs

* Fri Nov 21 2014 Elan Ruusamäe <glen@delfi.ee> 2f39775
- add bcond to enable/disable unittests build

* Thu Nov 20 2014 Elan Ruusamäe <glen@delfi.ee> f236902
- drop duplicate yasm check

* Thu Nov 20 2014 Elan Ruusamäe <glen@delfi.ee> a7d444e
- be clear that php is required for docs build

* Thu Nov 20 2014 Elan Ruusamäe <glen@delfi.ee> 5f38e72
- add ssse3 bcond, disable it on ac due old compiler

* Sun Dec 29 2013 Jakub Bogusz <qboosh@pld-linux.org> 488ced6
- use dropin

* Sun Dec 29 2013 Jakub Bogusz <qboosh@pld-linux.org> 1e75720
- updated to 1.3.0 (from git tag, not available on webm downloads)

* Sat Dec 28 2013 Jakub Bogusz <qboosh@pld-linux.org> 2001cd1
- updated to 1.2.0

* Fri Oct 05 2012 Elan Ruusamäe <glen@delfi.ee> 6195646
- fix misplaced if

* Sat Aug 11 2012 Elan Ruusamäe <glen@delfi.ee> e1331b3
-  add ppc/ppc64 targets. enable shared does not work on generic target

* Thu Aug 02 2012 Elan Ruusamäe <glen@delfi.ee> 7fb2034
- up to 1.1.0

* Thu Aug 02 2012 Elan Ruusamäe <glen@delfi.ee> 3c828a1
- requires yasm >= 0.8

* Fri Mar 02 2012 Jakub Bogusz <qboosh@pld-linux.org> 1c3357c
- updated to 1.0.0 (note: new soname; also fixes an OOB read decoder crash)

* Tue Dec 27 2011 Elan Ruusamäe <glen@pld-linux.org> 88a083f
- update to p1:
  2011-08-15 v0.9.7-p1 "Cayuga" patch 1
  Fix potential OOB reads (cdae03a)

* Sun Aug 07 2011 Jakub Bogusz <qboosh@pld-linux.org> 9026bd8
- updated to 0.9.7
- removed obsolete 0.9.0-no-explicit-dep-on-static-lib patch and unused external libvpx.ver
- package vpx.pc (adjusting wrt. proper prefix and libdir)

